doc: Remove the now unnecessary remark about PATH and link.exe
[ffmpeg.git] / doc / platform.texi
1 \input texinfo @c -*- texinfo -*-
2
3 @settitle Platform Specific information
4 @titlepage
5 @center @titlefont{Platform Specific information}
6 @end titlepage
7
8 @top
9
10 @contents
11
12 @chapter Unix-like
13
14 Some parts of Libav cannot be built with version 2.15 of the GNU
15 assembler which is still provided by a few AMD64 distributions. To
16 make sure your compiler really uses the required version of gas
17 after a binutils upgrade, run:
18
19 @example
20 $(gcc -print-prog-name=as) --version
21 @end example
22
23 If not, then you should install a different compiler that has no
24 hard-coded path to gas. In the worst case pass @code{--disable-asm}
25 to configure.
26
27 @section Advanced linking configuration
28
29 If you compiled Libav libraries statically and you want to use them to
30 build your own shared library, you may need to force PIC support (with
31 @code{--enable-pic} during Libav configure) and add the following option
32 to your project LDFLAGS:
33
34 @example
35 -Wl,-Bsymbolic
36 @end example
37
38 If your target platform requires position independent binaries, you should
39 pass the correct linking flag (e.g. @code{-pie}) to @code{--extra-ldexeflags}.
40
41 @section BSD
42
43 BSD make will not build Libav, you need to install and use GNU Make
44 (@command{gmake}).
45
46 @section (Open)Solaris
47
48 GNU Make is required to build Libav, so you have to invoke (@command{gmake}),
49 standard Solaris Make will not work. When building with a non-c99 front-end
50 (gcc, generic suncc) add either @code{--extra-libs=/usr/lib/values-xpg6.o}
51 or @code{--extra-libs=/usr/lib/64/values-xpg6.o} to the configure options
52 since the libc is not c99-compliant by default. The probes performed by
53 configure may raise an exception leading to the death of configure itself
54 due to a bug in the system shell. Simply invoke a different shell such as
55 bash directly to work around this:
56
57 @example
58 bash ./configure
59 @end example
60
61 @anchor{Darwin}
62 @section Darwin (OS X, iPhone)
63
64 The toolchain provided with Xcode is sufficient to build the basic
65 unacelerated code.
66
67 OS X on PowerPC or ARM (iPhone) requires a preprocessor from
68 @url{git://git.libav.org/gas-preprocessor.git} to build the optimized
69 assembly functions. Put the Perl script somewhere
70 in your PATH, Libav's configure will pick it up automatically.
71
72 OS X on AMD64 and x86 requires @command{yasm} to build most of the
73 optimized assembly functions @url{http://mxcl.github.com/homebrew/, Homebrew},
74 @url{http://www.gentoo.org/proj/en/gentoo-alt/prefix/bootstrap-macos.xml, Gentoo Prefix}
75 or @url{http://www.macports.org, MacPorts} can easily provide it.
76
77
78 @chapter DOS
79
80 Using a cross-compiler is preferred for various reasons.
81 @url{http://www.delorie.com/howto/djgpp/linux-x-djgpp.html}
82
83
84 @chapter OS/2
85
86 For information about compiling Libav on OS/2 see
87 @url{http://www.edm2.com/index.php/FFmpeg}.
88
89
90 @chapter Windows
91
92 @section Native Windows compilation using MinGW or MinGW-w64
93
94 Libav can be built to run natively on Windows using the MinGW-w64
95 toolchain. Install the latest versions of MSYS2 and MinGW-w64 from
96 @url{http://msys2.github.io/} and/or @url{http://mingw-w64.sourceforge.net/}.
97 You can find detailed installation instructions in the download section and
98 the FAQ.
99
100 Notes:
101
102 @itemize
103
104 @item Building natively using MSYS2 can be sped up by disabling implicit rules
105 in the Makefile by calling @code{make -r} instead of plain @code{make}. This
106 speed up is close to non-existent for normal one-off builds and is only
107 noticeable when running make for a second time (for example during
108 @code{make install}).
109
110 @item In order to compile AVplay, you must have the MinGW development library
111 of @uref{http://www.libsdl.org/, SDL} and @code{pkg-config} installed.
112
113 @item By using @code{./configure --enable-shared} when configuring Libav,
114 you can build all libraries as DLLs.
115
116 @end itemize
117
118 @section Microsoft Visual C++ or Intel C++ Compiler for Windows
119
120 Libav can be built with MSVC 2012 or earlier using a C99-to-C89 conversion utility
121 and wrapper, or with MSVC 2013 and ICL natively.
122
123 You will need the following prerequisites:
124
125 @itemize
126 @item @uref{https://github.com/libav/c99-to-c89/, C99-to-C89 Converter & Wrapper}
127 (if using MSVC 2012 or earlier)
128 @item @uref{http://code.google.com/p/msinttypes/, msinttypes}
129 (if using MSVC 2012 or earlier)
130 @item @uref{http://msys2.github.io/, MSYS2}
131 @item @uref{http://yasm.tortall.net/, YASM}
132 (Also available via MSYS2's package manager.)
133 @end itemize
134
135 To set up a proper environment in MSYS2, you need to run @code{msys_shell.bat} from
136 the Visual Studio or Intel Compiler command prompt.
137
138 Place @code{yasm.exe} somewhere in your @code{PATH}. If using MSVC 2012 or
139 earlier, place @code{c99wrap.exe} and @code{c99conv.exe} somewhere in your
140 @code{PATH} as well.
141
142 Next, make sure any other headers and libs you want to use, such as zlib, are
143 located in a spot that the compiler can see. Do so by modifying the @code{LIB}
144 and @code{INCLUDE} environment variables to include the @strong{Windows-style}
145 paths to these directories. Alternatively, you can try and use the
146 @code{--extra-cflags}/@code{--extra-ldflags} configure options. If using MSVC
147 2012 or earlier, place @code{inttypes.h} somewhere the compiler can see too.
148
149 Finally, run:
150
151 @example
152 For MSVC:
153 ./configure --toolchain=msvc
154
155 For ICL:
156 ./configure --toolchain=icl
157
158 make
159 make install
160 @end example
161
162 If you wish to compile shared libraries, add @code{--enable-shared} to your
163 configure options. Note that due to the way MSVC and ICL handle DLL imports and
164 exports, you cannot compile static and shared libraries at the same time, and
165 enabling shared libraries will automatically disable the static ones.
166
167 Notes:
168
169 @itemize
170
171 @item If you wish to build with zlib support, you will have to grab a compatible
172 zlib binary from somewhere, with an MSVC import lib, or if you wish to link
173 statically, you can follow the instructions below to build a compatible
174 @code{zlib.lib} with MSVC. Regardless of which method you use, you must still
175 follow step 3, or compilation will fail.
176 @enumerate
177 @item Grab the @uref{http://zlib.net/, zlib sources}.
178 @item Edit @code{win32/Makefile.msc} so that it uses -MT instead of -MD, since
179 this is how Libav is built as well.
180 @item Edit @code{zconf.h} and remove its inclusion of @code{unistd.h}. This gets
181 erroneously included when building Libav.
182 @item Run @code{nmake -f win32/Makefile.msc}.
183 @item Move @code{zlib.lib}, @code{zconf.h}, and @code{zlib.h} to somewhere MSVC
184 can see.
185 @end enumerate
186
187 @item Libav has been tested with the following on i686 and x86_64:
188 @itemize
189 @item Visual Studio 2010 Pro and Express
190 @item Visual Studio 2012 Pro and Express
191 @item Visual Studio 2013 Pro and Express
192 @item Intel Composer XE 2013
193 @item Intel Composer XE 2013 SP1
194 @end itemize
195 Anything else is not officially supported.
196
197 @end itemize
198
199 @subsection Linking to Libav with Microsoft Visual C++
200
201 If you plan to link with MSVC-built static libraries, you will need
202 to make sure you have @code{Runtime Library} set to
203 @code{Multi-threaded (/MT)} in your project's settings.
204
205 You will need to define @code{inline} to something MSVC understands:
206 @example
207 #define inline __inline
208 @end example
209
210 Also note, that as stated in @strong{Microsoft Visual C++}, you will need
211 an MSVC-compatible @uref{http://code.google.com/p/msinttypes/, inttypes.h}.
212
213 If you plan on using import libraries created by dlltool, you must
214 set @code{References} to @code{No (/OPT:NOREF)} under the linker optimization
215 settings, otherwise the resulting binaries will fail during runtime.
216 This is not required when using import libraries generated by @code{lib.exe}.
217 This issue is reported upstream at
218 @url{http://sourceware.org/bugzilla/show_bug.cgi?id=12633}.
219
220 To create import libraries that work with the @code{/OPT:REF} option
221 (which is enabled by default in Release mode), follow these steps:
222
223 @enumerate
224
225 @item Open the @emph{Visual Studio Command Prompt}.
226
227 Alternatively, in a normal command line prompt, call @file{vcvars32.bat}
228 which sets up the environment variables for the Visual C++ tools
229 (the standard location for this file is something like
230 @file{C:\Program Files (x86_\Microsoft Visual Studio 10.0\VC\bin\vcvars32.bat}).
231
232 @item Enter the @file{bin} directory where the created LIB and DLL files
233 are stored.
234
235 @item Generate new import libraries with @command{lib.exe}:
236
237 @example
238 lib /machine:i386 /def:..\lib\foo-version.def  /out:foo.lib
239 @end example
240
241 Replace @code{foo-version} and @code{foo} with the respective library names.
242
243 @end enumerate
244
245 @anchor{Cross compilation for Windows with Linux}
246 @section Cross compilation for Windows with Linux
247
248 You must use the MinGW cross compilation tools available at
249 @url{http://www.mingw.org/}.
250
251 Then configure Libav with the following options:
252 @example
253 ./configure --target-os=mingw32 --cross-prefix=i386-mingw32msvc-
254 @end example
255 (you can change the cross-prefix according to the prefix chosen for the
256 MinGW tools).
257
258 Then you can easily test Libav with @uref{http://www.winehq.com/, Wine}.
259
260 @section Compilation under Cygwin
261
262 Please use Cygwin 1.7.x as the obsolete 1.5.x Cygwin versions lack
263 llrint() in its C library.
264
265 Install your Cygwin with all the "Base" packages, plus the
266 following "Devel" ones:
267 @example
268 binutils, gcc4-core, make, git, mingw-runtime, texi2html
269 @end example
270
271 In order to run FATE you will also need the following "Utils" packages:
272 @example
273 diffutils
274 @end example
275
276 If you want to build Libav with additional libraries, download Cygwin
277 "Devel" packages for Ogg and Vorbis from any Cygwin packages repository:
278 @example
279 libogg-devel, libvorbis-devel
280 @end example
281
282 These library packages are only available from
283 @uref{http://sourceware.org/cygwinports/, Cygwin Ports}:
284
285 @example
286 yasm, libSDL-devel, libfaac-devel, libgsm-devel, libmp3lame-devel,
287 libschroedinger1.0-devel, speex-devel, libtheora-devel, libxvidcore-devel
288 @end example
289
290 The recommendation for x264 is to build it from source, as it evolves too
291 quickly for Cygwin Ports to be up to date.
292
293 @section Crosscompilation for Windows under Cygwin
294
295 With Cygwin you can create Windows binaries that do not need the cygwin1.dll.
296
297 Just install your Cygwin as explained before, plus these additional
298 "Devel" packages:
299 @example
300 gcc-mingw-core, mingw-runtime, mingw-zlib
301 @end example
302
303 and add some special flags to your configure invocation.
304
305 For a static build run
306 @example
307 ./configure --target-os=mingw32 --extra-cflags=-mno-cygwin --extra-libs=-mno-cygwin
308 @end example
309
310 and for a build with shared libraries
311 @example
312 ./configure --target-os=mingw32 --enable-shared --disable-static --extra-cflags=-mno-cygwin --extra-libs=-mno-cygwin
313 @end example
314
315 @chapter Plan 9
316
317 The native @uref{http://plan9.bell-labs.com/plan9/, Plan 9} compiler
318 does not implement all the C99 features needed by Libav so the gcc
319 port must be used.  Furthermore, a few items missing from the C
320 library and shell environment need to be fixed.
321
322 @itemize
323
324 @item GNU awk, grep, make, and sed
325
326 Working packages of these tools can be found at
327 @uref{http://code.google.com/p/ports2plan9/downloads/list, ports2plan9}.
328 They can be installed with @uref{http://9front.org/, 9front's} @code{pkg}
329 utility by setting @code{pkgpath} to
330 @code{http://ports2plan9.googlecode.com/files/}.
331
332 @item Missing/broken @code{head} and @code{printf} commands
333
334 Replacements adequate for building Libav can be found in the
335 @code{compat/plan9} directory.  Place these somewhere they will be
336 found by the shell.  These are not full implementations of the
337 commands and are @emph{not} suitable for general use.
338
339 @item Missing C99 @code{stdint.h} and @code{inttypes.h}
340
341 Replacement headers are available from
342 @url{http://code.google.com/p/plan9front/issues/detail?id=152}.
343
344 @item Missing or non-standard library functions
345
346 Some functions in the C library are missing or incomplete.  The
347 @code{@uref{http://ports2plan9.googlecode.com/files/gcc-apelibs-1207.tbz,
348 gcc-apelibs-1207}} package from
349 @uref{http://code.google.com/p/ports2plan9/downloads/list, ports2plan9}
350 includes an updated C library, but installing the full package gives
351 unusable executables.  Instead, keep the files from @code{gccbin.tgz}
352 under @code{/386/lib/gnu}.  From the @code{libc.a} archive in the
353 @code{gcc-apelibs-1207} package, extract the following object files and
354 turn them into a library:
355
356 @itemize
357 @item @code{strerror.o}
358 @item @code{strtoll.o}
359 @item @code{snprintf.o}
360 @item @code{vsnprintf.o}
361 @item @code{vfprintf.o}
362 @item @code{_IO_getc.o}
363 @item @code{_IO_putc.o}
364 @end itemize
365
366 Use the @code{--extra-libs} option of @code{configure} to inform the
367 build system of this library.
368
369 @item FPU exceptions enabled by default
370
371 Unlike most other systems, Plan 9 enables FPU exceptions by default.
372 These must be disabled before calling any Libav functions.  While the
373 included tools will do this automatically, other users of the
374 libraries must do it themselves.
375
376 @end itemize
377
378 @bye